<?php

namespace Drupal\cmlexchange\Protocol;

use Drupal\Core\Controller\ControllerBase;
use Drupal\cmlexchange\Controller\FileSave;

/**
 * CmlFile.
 */
class CmlFile extends ControllerBase {

  /**
   * Main.
   */
  public static function main($type = 'import') {
    $result = '';
    // Check Auth.
    if (CmlCheckAuth::auth() && $cml_id = CmlCheckAuth::check()) {
      // Check inpuf file.
      if (isset($_GET['filename']) && $content = file_get_contents('php://input')) {
        Cml::debug(__CLASS__, "Save {$cml_id}-{$type} {$_GET['filename']}");
        $fs = new FileSave();
        $file = $fs->file($content, $_GET['filename'], $cml_id, $type);
        if ($file) {
          \Drupal::moduleHandler()->alter('cmlexchange_file_load', $cml_id, $type);
          $result = "success\n";
        }
        else {
          $result = "failure\n";
          $result .= "Error during writing file.\n";
          Cml::debug(__CLASS__, "Ошибка при записи файла. Не нашли куку авторизации");
        }
      }
      else {
        $result = "failure\n";
        $result .= "filename error\n";
        if (!isset($_GET['filename'])) {
          Cml::debug(__CLASS__, "Ошибка загрузки файла, не определено имя файла. Import file");
        }
        if (!file_get_contents('php://input')) {
          Cml::debug(__CLASS__, "Ошибка при записи файла. Не нашли переданного файла в потоке.");
        }
      }
    }
    else {
      $result .= "failure\n";
      $result .= "auth error\n";
      if (!CmlCheckAuth::auth()) {
        Cml::debug(__CLASS__, "Ошибка авторизации. Base.");
      }
      if (!$cml_id = CmlCheckAuth::check()) {
        Cml::debug(__CLASS__, "Ошибка авторизации. Cookie.");
      }
    }

    Cml::debug(__CLASS__, "file result:\n" . $result);
    return $result;
  }

}
