<?php

namespace Drupal\cmlexchange\Protocol;

use Drupal\Core\Controller\ControllerBase;
use Drupal\cmlexchange\Controller\ImportPipeline;

/**
 * Controller routines for page example routes.
 */
class CmlImport extends ControllerBase {

  /**
   * Main.
   */
  public static function main() {
    if (CmlCheckAuth::auth() && $cml_id = CmlCheckAuth::check()) {
      Cml::debug(__CLASS__, "Import: $cml_id");
      $import = new ImportPipeline();
      $result = $import->process($cml_id);
      if ($result == 'progress') {
        return 'progress';
      }
      elseif ($result == 'success') {
        return 'success';
      }
      elseif ($result == 'failure' || $result == FALSE) {
        return 'failure';
      }
      return 'success';
    }
    else {
      $result .= "failure\n";
      $result .= "auth error\n";
      Cml::debug(__CLASS__, "Ошибка авторизации. Base.");
      return $result;
    }
  }

}
