<?php

namespace Drupal\cmlexchange\Protocol;

use Drupal\Core\Controller\ControllerBase;
use Drupal\cmlexchange\Controller\Orders;
use Drupal\cmlexchange\Controller\FileSave;

/**
 * Controller routines for page example routes.
 */
class CmlQuery extends ControllerBase {

  /**
   * Main.
   */
  public static function main($type) {
    if (CmlCheckAuth::auth()) {
      $cml_id = CmlCheckAuth::check();
      if ($type == 'sale') {
        $filename = 'export.xml';
        $xml = Orders::init();
        $fs = new FileSave();
        $file = $fs->file($xml, $filename, $cml_id, $type);
        $cml = \Drupal::entityManager()->getStorage('cml')->load($cml_id);
        if ($file) {
          $cml->setState('success');
          $cml->save();
          header("Cache-Control: private");
          header('Content-Type: application/xml');
          header('Content-Length: ' . strlen($xml));
          header("Content-Disposition: attachment; filename=$filename");
          header('Cache-Control: public');
          header('Pragma: no-cache');
          header("Expires: 0");
          die($xml);
        }
        else {
          $cml->setState('failure');
          $cml->save();
          $result = "failure\n";
          $result .= "unknown type\n";
        }

      }
      else {
        $result = "failure\n";
        $result .= "unknown type\n";
      }
      Cml::debug(__CLASS__, "sale mode query " . $cml_id);
    }
    else {
      $result = "failure\n";
      $result .= "auth error\n";
      Cml::debug(__CLASS__, "Ошибка авторизации. Base.");
    }
    return $result;
  }

}
